#ifndef _AReferenceCountedObject_hpp_
#define _AReferenceCountedObject_hpp_

// Copyright (c) 1997-2000 Askesis B.V. See licence.txt for details.
// For information, bug reports and additions send e-mail to ALib@Askesis.nl

// Author : Joost Kraaijeveld
// Created: 18 Jan 1998 21:35:43
// Purpose:
//

// Configuration file

// Standard C/C++ library headers

// Operating system toolkit headers

// STL headers

// Other class headers
#include "ARCPointer.hpp"

// Forward declarations

class ALIBIMPEXP AReferenceCountedObject
{
   public:
      // Constructors
      AReferenceCountedObject();

      // Destructor
      virtual ~AReferenceCountedObject();

      // Operators

      // Accessors
      unsigned                                  getReferenceCounter() const
      {
         return this->referenceCounter;
      }

      // Mutators

      // Operations
      virtual void                              addReference();
      virtual void                              removeReference();

      // Attributes

   protected:
      // Attributes

      // Operations

   private:
      // Friends

      // Operations

      // Attributes
      unsigned long                             referenceCounter;
}; // End of class declaration of AReferenceCountedObject
#endif
