#ifndef _ANamedEventObject_hpp_
#define _ANamedEventObject_hpp_

// Copyright (c) 1997-2000 Askesis B.V. See licence.txt for details.
// For information, bug reports and additions send e-mail to ALib@askesis.nl

// Author : Joost Kraaijeveld
// Created: 18 Jan 1998 20:17:33
// Purpose:

// Configuration file
#include "ALibBase.h"

// Standard C/C++ library headers

// Operating system toolkit headers

// STL headers

// Other class headers
#include "ASynchronizationObject.hpp"

// Forward declarations

class ALIBIMPEXP ANamedEventObject : public ASynchronizationObject
{
   public:
      // Constructors
      ANamedEventObject(const char* aName) : name(aName){}


      // Destructor
      virtual ~ANamedEventObject(){}

      // Operators

      // Accessors
      string&                                   getName() const {return (string&)name;}

      // Mutators

      // Operations

      // Attributes

   protected:
      // Attributes

      // Operations

   private:
      // Friends

      // Operations
      ANamedEventObject(const ANamedEventObject& aANamedEventObject){}
      ANamedEventObject& operator=(const ANamedEventObject& aANamedEventObject){return *this;}

      // Attributes
      string                                    name;
}; // End of class declaration of ANamedEventObject
#endif
