#ifndef _ANamedMutexObject_hpp_
#define _ANamedMutexObject_hpp_

// Copyright (c) 1997-2000 Askesis B.V. See licence.txt for details.
// For information, bug reports and additions send e-mail to ALib@askesis.nl

// Author : Joost Kraaijeveld
// Created: 18 Jan 1998 20:17:31
// Purpose: ISharedResource clone

// Configuration file
#include "ALibBase.h"

// Standard C/C++ library headers

// Operating system toolkit headers

// STL headers

// Other class headers
#include "ASynchronizationObject.hpp"

// Forward declarations

class ALIBIMPEXP ANamedMutexObject : public ASynchronizationObject
{
   public:
      // Constructors
      ANamedMutexObject(const char* aName);

      // Destructor
      virtual ~ANamedMutexObject();

      // Operators

      // Accessors
      string&                                   getName() const {return (string&)name;}

      // Mutators

      // Operations

      // Attributes

   protected:
      // Attributes

      // Operations

   private:
      // Friends

      // Operations
      ANamedMutexObject(const ANamedMutexObject& aANamedMutexObject);
      ANamedMutexObject& operator =(const ANamedMutexObject& aANamedMutexObject);

      // Attributes
      string                                    name;
}; // End of class declaration of ANamedMutexObject
#endif // _ANamedMutexObject_hpp_
