#ifndef _ANamedSemaphoreObject_hpp_
#define _ANamedSemaphoreObject_hpp_

// Copyright (c) 1997-2000 Askesis B.V. See licence.txt for details.
// For information, bug reports and additions send e-mail to ALib@askesis.nl

// Author : Joost Kraaijeveld
// Created: 18 Jan 1998 20:17:25
// Purpose:

// Configuration file
#include "ALibBase.h"

// Standard C/C++ library headers

// Operating system toolkit headers

// STL headers

// Other class headers
#include "ASynchronizationObject.hpp"

// Forward declarations

class ALIBIMPEXP ANamedSemaphoreObject : public ASynchronizationObject
{
   public:
      // Constructors
      ANamedSemaphoreObject(  const char* aName) : name(aName){}

      // Destructor
      virtual ~ANamedSemaphoreObject(){}

      // Operators

      // Accessors
      string&                                   getName() const {return (string&)name;}

      // Mutators

      // Operations

      // Attributes

   protected:
      // Attributes

      // Operations

   private:
      // Friends

      // Operations
      ANamedSemaphoreObject(  const ANamedSemaphoreObject& aANamedSemaphoreObject){}
      ANamedSemaphoreObject& operator=(const ANamedSemaphoreObject& aANamedSemaphoreObject){return *this;}

      // Attributes
      string                                    name;
}; // End of class declaration of ANamedSemaphoreObject
#endif // _ANamedSemaphoreObject_hpp_
