#ifndef _APlatform_hpp_
#define _APlatform_hpp_

// Copyright (c) 1997-2000 Askesis B.V. See licence.txt for details.
// For information, bug reports and additions send e-mail to ALib@Askesis.nl

// Author : Joost Kraaijeveld
// Created: 14 Dec 1997 15:46:13
// Purpose:

// Configuration file
#include "ALibBase.h"

// Standard C/C++ library headers

// Operating system toolkit headers
#ifdef __ALIBWINDOWS__
#include <windows.h>
#endif // __ALIBWINDOWS__

// Is there an equivelant UNIX file needed ??
#ifdef __ALIBLINUX__
#endif // __ALIBLINUX__


// Other class headers

// Forward declarations

class ALIBIMPEXP APlatform
{
   public:
      ~APlatform();
      static bool                               isWin32();
      static bool                               isWinNT();
      static bool                               isWin32S();
      static bool                               isWin95();
      static bool                               isLinux();

   protected:
      static APlatform                          platform;

   private:
      APlatform();
      static bool                               win32;
      static bool                               winNT;
      static bool                               win32s;
      static bool                               win95;
      static bool                               linux;
};
#endif // _APlatform_hpp_
